/*
  Blink
  Turns on an LED on for one second, then off for one second, repeatedly.
 
  This example code is in the public domain.
 */
 
#include <Wire.h>
#include <GOFi2cOLED.h>

GOFi2cOLED GOFoled;

#define Btn_Ok        2
#define Btn_U         3
#define Btn_D         4 

#define PIC_5V        6
#define PIC_Up        5
#define PIC_Dn        0
#define PIC_Ok        7
#define PIC_Hz        9
#define PIC_Led       10



byte Mode = 0;
byte Old_Mode = 20;
byte OscCal = 0;
byte Stage = 0;
byte Menu = 0;
int E_h = 0;
int E_l = 0;

unsigned int  PIC_f = 0;
float         old_us = 0;
float         new_us = 0;

// the setup routine runs once when you press reset:
void setup() {                
  // initialize the digital pins
  pinMode(Btn_Ok,INPUT_PULLUP);
  pinMode(Btn_U,INPUT_PULLUP);
  pinMode(Btn_D,INPUT_PULLUP);

  // set outputs to PIC
  pinMode(PIC_5V,INPUT);
  pinMode(PIC_Hz,INPUT);
  pinMode(PIC_Led,INPUT);
  pinMode(PIC_Up,INPUT_PULLUP);
  pinMode(PIC_Dn,INPUT_PULLUP);
  pinMode(PIC_Ok,INPUT_PULLUP);
  delay(500);


  // default slave address is 0x3C
  GOFoled.init(0x3C);  //initialze  OLED display
  GOFoled.clearDisplay();
  Mode = 0;
  Menu = 0;
  // welcome screen
  GOFoled.setCursor(0,0);
  GOFoled.setTextSize(2);
  GOFoled.setTextColor(WHITE);
  GOFoled.print("  12F675  ");
  GOFoled.setCursor(0,24);
  GOFoled.print("  Multi   ");
  GOFoled.setCursor(0,49);
  GOFoled.print("  Tool    ");
  GOFoled.display();  
  GOFoled.clearDisplay();
  delay(3000);  
}

// the loop routine runs over and over again forever:
void loop() {
  if (Menu == 0) Function_Select();
  if (Menu == 1) Function_Program();
  if (Menu == 2) Function_OscCal();
  if (Menu == 3) Function_Test01();

}

//===================================================================================
void Function_Select() {
//===================================================================================
  if ( (digitalRead(Btn_Ok) == 0) ){
    delay(50);
    switch(Mode) {
      case 0: Menu = 1;    
              Mode = 0;    
              break;
      case 1: Menu = 2;  
              Mode = 0;
              break;
      case 2: Menu = 3;  
              Mode = 0;
              break;
    }
    while (digitalRead(Btn_Ok) == 0) {
      delay(50);               // wait for a second
    }
    delay(50);
  }

  if (digitalRead(Btn_U) == 0){
    delay(50);

    if (Mode > 0) {
      Mode = Mode - 1;
    }
    else {
      Mode = 2;
    }

    while (digitalRead(Btn_U) == 0) {
      delay(50);               // wait for a second
    }
    delay(50);
  }

  if ( (digitalRead(Btn_D) == 0) ){
    delay(50);
    
    Mode = Mode + 1;
    if (Mode > 2) Mode = 0;

    while (digitalRead(Btn_D) == 0) {
      delay(50);               // wait for a second
    }
    delay(50);
  }
 
  if (Old_Mode != Mode) { 
    if (Mode == 0) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);
      
      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("> Pgm PIC ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  Pgm Osc ");
      GOFoled.setCursor(0,49);
      GOFoled.print("  Tst R/C ");
      GOFoled.display();  
      GOFoled.clearDisplay();
     }
     
    if (Mode == 1) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);
      
      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  Pgm PIC ");
      GOFoled.setCursor(0,24);
      GOFoled.print("> Pgm Osc ");
      GOFoled.setCursor(0,49);
      GOFoled.print("  Tst R/C ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }     

    if (Mode == 2) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);
      
      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  Pgm PIC ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  Pgm Osc ");
      GOFoled.setCursor(0,49);
      GOFoled.print("> Tst R/C ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }     
  }
}

//===================================================================================
void Function_Program() {
//===================================================================================
    // Scan buttons
  if ( (digitalRead(Btn_Ok) == 0) ){
    delay(50);
    switch(Mode) {
      case 1: Mode = 2;        
              break;
      case 2: Mode = 3;  
              break;
      case 3: Mode = 4;        
              break;
      case 4: Mode = 3;   
              break;
    }
     
    while ((digitalRead(Btn_Ok) == 0) ) {
      delay(50);               // wait for a second
    }
    delay(50);
  }

  
  if ( ( digitalRead(Btn_D) == 0) or ( digitalRead(Btn_U) == 0) ) {
    if (Mode == 3) {
      Mode = 0;
      Old_Mode = 10;
      Menu = 0;
      while ( (digitalRead(Btn_U) == 0) or (digitalRead(Btn_D) == 0)) {
        delay(50);               // wait for a second
      }
      delay(50);
      return;
    }
  }    
  
  if (Old_Mode != Mode) { 
    if (Mode == 0) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);
      
      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("PIC 12F675");
      GOFoled.setCursor(0,24);
      GOFoled.print("Programmer");
      GOFoled.setCursor(0,49);
      GOFoled.print("          ");
      GOFoled.display();  
      GOFoled.clearDisplay();
      delay(3000);
      Mode = 1;
     }
  
    if (Mode == 1) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  CONNECT ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  PICkit  ");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }

    if (Mode == 2) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  SETUP   ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  MPLab   ");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }

    if (Mode == 3) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  INSERT  ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  12F675  ");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }
    if (Mode == 4) {
       // set outputs to PIC
      pinMode(PIC_5V,OUTPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,HIGH);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print(" PROGRAM  ");
      GOFoled.setCursor(0,24);
      GOFoled.print("PIC 12F675");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }
    Old_Mode = Mode;
  }
}

//===================================================================================
void Function_OscCal() {
//===================================================================================
    // Scan buttons
  if (digitalRead(Btn_Ok) == 0){
    delay(50);
    switch(Mode) {
      case 1: Mode = 2;        
              break;
      case 2: Mode = 3;  
              OscCal = 0; 
              break;
      case 3: Mode = 4;        
              break;
      case 4: Mode = 5;   
              OscCal = 0; 
              break;
      case 6: Mode = 3;   
              break;
      case 7: Mode = 3;   
              break;
    }
    
    while ((digitalRead(Btn_Ok) == 0) ) {
      delay(50);               // wait for a second
    }
    delay(50);
   }
   
  if ( ( digitalRead(Btn_D) == 0) or ( digitalRead(Btn_U) == 0) ) {
    if (Mode == 3) {
      Mode = 1;
      Old_Mode = 10;
      Menu = 0;
      while ( (digitalRead(Btn_U) == 0) or (digitalRead(Btn_D) == 0)) {
        delay(50);               // wait for a second
      }
      delay(50);
      return;
    }
  }    
  
  if (Old_Mode != Mode) { 
    if (Mode == 0) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);
      
      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("PIC 12F675");
      GOFoled.setCursor(0,24);
      GOFoled.print("  OscCal  ");
      GOFoled.setCursor(0,49);
      GOFoled.print("Calibrator");
      GOFoled.display();  
      GOFoled.clearDisplay();
      delay(3000);
      Mode = 1;
     }
  
    if (Mode == 1) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  CONNECT ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  PICkit  ");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }

    if (Mode == 2) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  SETUP   ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  MPLab   ");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }

    if (Mode == 3) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  INSERT  ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  12F675  ");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }
    if (Mode == 4) {
       // set outputs to PIC
      pinMode(PIC_5V,OUTPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,HIGH);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print(" PROGRAM  ");
      GOFoled.setCursor(0,24);
      GOFoled.print("OscCal.hex");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
      OscCal = 0;    
      Stage = 0; 
    }

    if (Mode == 5) {
       // set outputs to PIC
      pinMode(PIC_5V,OUTPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,OUTPUT);
      pinMode(PIC_Dn,OUTPUT);
      pinMode(PIC_Ok,OUTPUT);
      
      digitalWrite(PIC_5V,HIGH);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.display();  
      GOFoled.clearDisplay();
    }

    if (Mode == 6) {
       // set outputs to PIC
      pinMode(PIC_5V,OUTPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,HIGH);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("OscCal= ");
      GOFoled.print(OscCal,HEX);
      GOFoled.setCursor(0,24);
      GOFoled.print("Program IC");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }

    if (Mode == 7) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);


      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("PIC 12F675");
      GOFoled.setCursor(0,24);
      GOFoled.print("not found!");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }
    
    Old_Mode = Mode;
  }

  // read frequency
  if (Mode == 5) {
    
    // check if 1000Hz signal is present
    old_us = millis();
    //wait for falling edge
    while (digitalRead(PIC_Hz) == 1) {
      if ( (millis() - old_us) > 500) {
        Mode = 7;
        Stage = 7;
        break;
      }
    }
    old_us = millis();
     //wait for rising edge
    while (digitalRead(PIC_Hz) == 0) {
      if ( (millis() - old_us) > 500) {
        Mode = 7;
        Stage = 7;
        break;
      }
    }   
    
    
    //measure frequency
    if (Stage != 7) {
      //wait for falling edge
      while (digitalRead(PIC_Hz) == 1) {
      }
      //wait for rising edge
      while (digitalRead(PIC_Hz) == 0) {
      }
      //start timer
      old_us = micros();
      for (byte i = 0; i < 100; i++ ) {
        //wait for falling edge
        while (digitalRead(PIC_Hz) == 1) {
        }
        //wait for rising edge
        while (digitalRead(PIC_Hz) == 0) {
        }
      }
      // stop timer
      new_us = micros();
      new_us = new_us - old_us;
      new_us = 100000000 / new_us;
      PIC_f = new_us;
    
      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("Get 1000Hz");
      GOFoled.setCursor(0,24);
      GOFoled.print("f =");
      GOFoled.setCursor(48,24);
      if (PIC_f < 1000) GOFoled.print(" ");
      if (PIC_f < 100) GOFoled.print(" ");
      if (PIC_f < 10) GOFoled.print(" ");
      GOFoled.print(PIC_f);
      GOFoled.setCursor(96,24);
      GOFoled.print("Hz");
      GOFoled.setCursor(0,49);
      GOFoled.print("  Wait..  ");
      GOFoled.display();  
      GOFoled.clearDisplay();
     }
   
    //auto adjust freq
    //================
    
    //step up to just over 1000Hz
    if ( (PIC_f < 1000) and (Stage == 0) ) {
      digitalWrite(PIC_Up,LOW);
      delay(5);
      digitalWrite(PIC_Up,HIGH);
      delay(100);
      OscCal = OscCal + 4; 
    }
    //at 1000Hz or above. Get error
    if ( (PIC_f >= 1000) and (Stage == 0) ) {
      E_h = PIC_f - 1000;
      Stage = 1;
    }

    //step down to just under 1000Hz
    if ( (PIC_f >= 1000) and (Stage == 1) ) {
      digitalWrite(PIC_Dn,LOW);
      delay(5);
      digitalWrite(PIC_Dn,HIGH);
      delay(100);
      OscCal = OscCal - 4; 
    }
    //at 1000hZ or above. Get + error
    if ( (PIC_f < 1000) and (Stage == 1) ) {
      E_l = 1000 - PIC_f;
      Stage = 2;
    }
   
    if (Stage == 3) Stage = 4;
   
    //determine smallest error
    if (Stage == 2) {
      if (E_h < E_l) {
        digitalWrite(PIC_Up,LOW);
        delay(5);
        digitalWrite(PIC_Up,HIGH);
        delay(100);
        OscCal = OscCal + 4; 
        Stage = 3;
      }
      else {
        Stage = 3;      
      }
    }
      
    if (Stage == 4) {
      //save data in EEPROM
      digitalWrite(PIC_Ok,LOW);
      delay(5);
      digitalWrite(PIC_Ok,HIGH);
      delay(1000);
      
      //wait for PIC to finish saving
      while(digitalRead(PIC_Led) == 0) {
      }
      //turn off PIC
      pinMode(PIC_5V,OUTPUT);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      digitalWrite(PIC_5V,HIGH);
      Mode = 6;
      Stage = 0;
    }
  }
}

//===================================================================================
void Function_Test01() {
//===================================================================================
    // Scan buttons
  if ( (digitalRead(Btn_Ok) == 0) ){
    delay(50);
    switch(Mode) {
      case 1: Mode = 2;        
              break;
      case 3: Mode = 1;        
              break;
    }
     
    while ((digitalRead(Btn_Ok) == 0) ) {
      delay(50);               // wait for a second
    }
    delay(50);
  }

  if ( ( digitalRead(Btn_D) == 0) or ( digitalRead(Btn_U) == 0) ) {
    if (Mode == 1) {
      Mode = 2;
      Old_Mode = 10;
      Menu = 0;
      while ( (digitalRead(Btn_U) == 0) or (digitalRead(Btn_D) == 0)) {
        delay(50);               // wait for a second
      }
      delay(50);
      return;
    }
  }    
  
  if (Old_Mode != Mode) { 
    if (Mode == 0) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);
      
      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("R/C Switch");
      GOFoled.setCursor(0,24);
      GOFoled.print("  Tester  ");
      GOFoled.setCursor(0,49);
      GOFoled.print("          ");
      GOFoled.display();  
      GOFoled.clearDisplay();
      delay(3000);
      Mode = 1;
     }
  
    if (Mode == 1) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("  INSERT  ");
      GOFoled.setCursor(0,24);
      GOFoled.print("  12F675  ");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }
    if (Mode == 2) {
       // set outputs to PIC
      pinMode(PIC_5V,OUTPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,HIGH);
      digitalWrite(PIC_Up,HIGH);
      digitalWrite(PIC_Dn,HIGH);
      digitalWrite(PIC_Ok,HIGH);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("Testing...");
      GOFoled.setCursor(0,24);
      GOFoled.print("          ");
      GOFoled.setCursor(0,49);
      GOFoled.print("          ");
      GOFoled.display();  
      GOFoled.clearDisplay();
      delay(2500);
      Mode = 3;
    }

    if (Mode == 3) {
       // set outputs to PIC
      pinMode(PIC_5V,INPUT);
      pinMode(PIC_Hz,INPUT_PULLUP);
      pinMode(PIC_Led,INPUT_PULLUP);
      pinMode(PIC_Up,INPUT_PULLUP);
      pinMode(PIC_Dn,INPUT_PULLUP);
      pinMode(PIC_Ok,INPUT_PULLUP);
      
      digitalWrite(PIC_5V,LOW);
      digitalWrite(PIC_Up,INPUT_PULLUP);
      digitalWrite(PIC_Dn,INPUT_PULLUP);
      digitalWrite(PIC_Ok,INPUT_PULLUP);

      GOFoled.setCursor(0,0);
      GOFoled.setTextSize(2);
      GOFoled.setTextColor(WHITE);
      GOFoled.print("PIC Passed");
      GOFoled.setCursor(0,24);
      GOFoled.print("          ");
      GOFoled.setCursor(0,49);
      GOFoled.print(" Press Ok ");
      GOFoled.display();  
      GOFoled.clearDisplay();
    }

    Old_Mode = Mode;
  }
}


